﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;

namespace XamGroupError
{

    public class DataItem : INotifyPropertyChanged
    {
        private string _a;
        public string A
        {
            get
            {
                return _a;
            }
            set
            {
                _a = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("A"));
                }
            }
        }

        private string _b;
        public string B
        {
            get
            {
                return _b;
            }
            set
            {
                _b = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("B"));
                }
            }
        }

        private string _c;
        public string C
        {
            get
            {
                return _c;
            }
            set
            {
                _c = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("C"));
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class DataContainer
    {
        private static List<string> _list = new List<string>() { "aaa", "AAA", "abab", "bcbc", "acac" };
        public ObservableCollection<DataItem> Items { get; set; }
        public List<string> StrList { get { return _list; } }
        public DataContainer()
        {
            Items = new ObservableCollection<DataItem>();
        }
    }
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        
        private DataContainer _cont;
        public MainWindow()
        {
            InitializeComponent();
            this.grid.InitializeRecordDirect += new EventHandler<InitializeRecordEventArgs>(grid_InitializeRecordDirect);
            _cont = new DataContainer();

            // add 3 rows
            _cont.Items.Add(new DataItem() { A = "bcbc", B = "b1", C = "c1" });
            _cont.Items.Add(new DataItem() { A = "acac", B = "b2", C = "c2" });
            _cont.Items.Add(new DataItem() { A = "abab", B = "b3", C = "c3" });

            this.DataContext = _cont;

            //this.grid.Loaded += new RoutedEventHandler(grid_Loaded);

            //System.Timers.Timer timer = new System.Timers.Timer(30 * 1000);
            //timer.Elapsed += new System.Timers.ElapsedEventHandler(timer_Elapsed);
            //timer.Enabled = true;
            //timer.Start();


        }

        private bool _isInEditMode = false;

        private void editModeStarting(object sender, EditModeStartingEventArgs e)
        {
            try
            {
                if (!_isInEditMode)
                {
                    _isInEditMode = true;
                }
                else
                {
                    return;
                }

                //if (e.Editor != null && e.Editor is XamComboEditor)
                //{
                //    var combo = e.Editor as XamComboEditor;

                //    combo.IsDropDownOpen = true;
                //    if (String.Equals(e.Cell.Field.Name, "A"))
                //    {
                //        combo.ItemsSource = _list;
                //    }
                //}
            }
            finally
            {
                _isInEditMode = false;
            }

        }

        void grid_Loaded(object sender, RoutedEventArgs e)
        {
            // group by col B
            this.grid.FieldLayouts[0].SortedFields.Add(new FieldSortDescription("B", ListSortDirection.Ascending, true));

        }

        /// <summary>
        /// Below method seems to have e.SortValueChanged to true in 12.1
        /// but false in 12.2.2057. this causes my sorting not to be invvoked
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void grid_InitializeRecordDirect(object sender, InitializeRecordEventArgs e)
        {
            if (e.SortValueChanged)
            {
                e.Record.RefreshSortPosition();
            }
        }

        void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            // re grouping should happen
            _cont.Items[1].B = "b1";
        }

    }
}
